/*------------------------------------------------------------------------------------
Copyright (c)2000 TogetherSoft Corporation. Patents pending. All rights reserved.
------------------------------------------------------------------------------------*/

package com.togethersoft.modules.xmleditor.api;

import java.util.*;
import com.togethersoft.openapi.rwi.*;

public interface XmlElementNode
{
  String getName();
  String getValue();

  /**
   * Returns the model RWI-element associated with this XML-element
   */
  public RwiElement getRwiElement();

  XmlElementNode getRootElement();
  XmlElementNode getParentElement();

  Enumeration    getChildElements();
  Enumeration    getChildElements (String name);
  XmlElementNode findChildElement (String name);

  Enumeration    getSubtreeElements();
  Enumeration    getSubtreeElements (String name);
  XmlElementNode findSubtreeElement (String name);

  boolean          hasAttributes();
  Enumeration      getAttributes();
  XmlAttributeNode findAttribute (String name);

}
